/* Iria - An easy-customizing game, in the way of "Thunder Force IV".
 * Created by Juan Jos Ramrez. Synthetyx Software.
 *
 * effects.c - Stars and snow effects
 *
 */

#include "effects.h"
float_pos_struct *stars;	// Three stars levels

/* This function draws all the stars and make them move */
int draw_stars(int vpos, int height) {
	int i;

	if (!stars) {	// First time
		if (!(stars = (float_pos_struct *) malloc(MAX_STARS * sizeof(float_pos_struct))))
			return NOT_ENOUGH_MEMORY;
		for (i = 0; i < MAX_STARS; i++) {
			stars[i].x = (float) (random() % WIDTH);
			stars[i].y = (float) (random() % height);
			stars[i].speed = (float) (random() % STARS_MAXSPEED) / 10;
		}
	}

	for (i = 0; i < MAX_STARS; i++) {
		if (stars[i].x < 0) 
			stars[i].x = WIDTH - stars[i].x;
		stars[i].x -= stars[i].speed;
#ifdef USE_SVGALIB
		if (stars[i].speed < STARS_DEEP)
			gl_setpixel((int) stars[i].x, (int) stars[i].y - vpos, 0x8C);
		else
			gl_setpixel((int) stars[i].x, (int) stars[i].y - vpos, 0x91);
#endif
	}

	return GOODBYE_OK;
}

/* This function unloads all stars */
void destroy_stars() {
	free(stars);
}
