/* Iria - An easy-customizing game, in the way of "Thunder Force IV".
 * Created by Juan Jos Ramrez. Synthetyx Software.
 *
 * graphedit.h - Some definitions...
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <vgakeyboard.h>
#include <signal.h>
#include <sys/time.h>
#include <png.h>
#include "returns.h"
#include "readpng.h"
#include "writepng.h"

/* Now a lot of parameters... */
#define VERSION "Graphics Editor for Iria, v0.6.0"
#define palboxsize 5	/* Size of the black box which rounds each colors */
#define palcolorsize palboxsize - 1 /* Size of each color box */ 
#define palX 275	/* Horizontal position of the palette box which contains colors */
#define palY 0	/* Vertical position */
#define palrows 35	/* Number of rows in the palette box */
#define palcolumns !(MAXPALCOLORS % palrows)?MAXPALCOLORS / palrows:(MAXPALCOLORS / palrows) + 1	/* Number of columns */
#define palwidth palcolumns * palboxsize 	/* The palette width */
#define palheight palrows * palboxsize	/* The palette height */
#define workX 0 	/* Horizontal position of the work area which we draw things */
#define workY 0	/* Vertical position */
#define workwidth palX - 1	/* Work area width */
#define workheight palrows * palboxsize  	/* Work area height */
#define currcolX palX + 5	/* Current color box horizontal position */
#define currcolY palY + palrows * palboxsize + 5 /* Current color box vertical position */
#define currcolsize 20 /* Current color box size */
#define zoombuttonX 1 /* Position of the zoom button */
#define zoombuttonY 175
#define centerbuttonX 55
#define centerbuttonY 175
#define clearbuttonX 110
#define clearbuttonY 175
#define copybuttonX 165
#define copybuttonY 175
#define exitbuttonX 224
#define exitbuttonY 175
#define buttoncolor 0x25 /* All buttons color */
#define buttonwidth 50 /* All buttons width */
#define buttonheight 9 /* All buttons height */
#define TITLEX 0
#define TITLEY 190
#define TITLECOLOR WHITE
#define PAL_DELAY 500

/* For the image variable... */
#define MAXWIDTH workwidth - 1	/* The image buffer width of the work area... */
#define MAXHEIGHT workheight - 1	/* The image buffer height of the work area... */

/* For getpossition function... */
#define ON_NONE 0
#define ON_PALETTE 1 	/* The pointer is over palette area */
#define ON_WORK 2	/* The pointer is over work area */
#define ON_ZOOM 3	/* The pointer is over the zoom button */
#define ON_CENTER 4	/* The pointer is over the center button */
#define ON_CLEAR 5	/* The pointer is over the clear button */
#define ON_COPY 6	/* The pointer is over the copy button */
#define ON_EXIT 7	/* The pointer is over the exit button */


#define GRAPHMODE G320x200x256
#define SCREEN_WIDTH 320
#define SCREEN_HEIGHT 200
#define MAXPALCOLORS 256
#define BLACK 0x89
#define WHITE 0x91
#define column png_bytep

/* Error definitions */
#define GOODBYE_OK 0
#define NOT_ENOUGH_MEMORY 1
#define FILE_DOESNT_EXIST 2
