/* Iria - An easy-customizing game, in the way of "Thunder Force IV".
 * Created by Juan Jos Ramrez. Synthetyx Software.
 *
 * iria.h - Some definitions for iria's modules
 *
 */

#include <png.h>
#include <signal.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "structs.h"
#include "returns.h"
#include "current.h"
#include "readpng.h"
#include "lists.h"
#include "loadfiles.h"
#include "unloadfiles.h"
#include "effects.h"
#ifdef USE_SVGALIB
	#include "svgalibg.h"
#endif

#define IRIA_VERSION "v0.3.5"
#define SCREEN_LIMIT 30		// This is the limit for the scenery go up or down
#define INMORTALITY_DURATION 100	// Inmortality duration when a new human is created
#define DEFAULT_LIVES 3
#define FPS 1400	// Miliseconds needed for keeping x frames per second
#define EXIT_IF_NO_MEMORY if (result == NOT_ENOUGH_MEMORY) { \
							printf("I haven't enough memory\n"); \
							exit(NOT_ENOUGH_MEMORY); \
					  	   }
#define FALSE 0
#define TRUE 1

typedef struct {
	int KEYUP,		// Move up
		KEYDOWN,	// Move down
		KEYRIGHT,	// Move to the right
		KEYLEFT,	// Move to the left
		KEYSHOOT,	// Shoot
		KEYCHANGE,	// Change weapon
		KEYRELEASED;	// Weapon button released
} player_keys;

extern object_struct  *object_index;	// Objects array with its events. See README.objects and README.events for more details
