/* Iria - An easy-customizing game, in the way of "Thunder Force IV".
 * Created by Juan Jos Ramrez. Synthetyx Software.
 *
 * loadfiles.h - Definitions and function prototypes for loadfiles.c
 *
 */

#define SKIP_SCN_HEADER fseek(f, sizeof(scn_header), SEEK_SET);
#define SKIP_OBJ_HEADER fseek(f, sizeof(obj_header), SEEK_SET);

/*
 * This function returns the position of the file in the array. That's the
 * object id.
 */
extern unsigned long int find_object_id(char *filename, string_list files);

/*
 * This function returns a pointer to the image bitmap or NULL if there are 
 * errors. If the image is a compiled mask image, we will compile it
 */
extern image_list find_image_id(char *filename, image_list *images, char compiled, imagefile_list *images_loaded);

/*
 * This function finds out which files I need. Since every .scn or .iri files
 * has several references to other files, I need to explore them
 */
extern int which_files_I_need(char *scn_filename, string_list *files, unsigned long int *number_of_objects);

/* This function inserts events into the list */
extern int load_events(FILE *f, event_list *l, string_list files, image_list *images, imagefile_list *images_loaded);

/* This function loads the scenery file to memory */
extern int load_scenery(char *filename, scenery_struct *s, string_list files, image_list *images, imagefile_list *images_loaded);

/*
 * This function loads all objects into an array. The array index is the
 * object id. 
 */
extern int load_objects(string_list files, object_struct **objects, image_list *images, imagefile_list *images_loaded);

