/* Iria - An easy-customizing game, in the way of "Thunder Force IV".
 * Created by Juan Jos Ramrez. Synthetyx Software.
 *
 * mngevents.h - Some external prototypes and data structures for mngevents.c
 *
 */

#include <stdio.h>
#include <unistd.h>
#include "structs.h"
#include "current.h"
#ifndef SKIP_HEADER
	#define SKIP_HEADER fseek(f, sizeof(header_record), SEEK_SET);
#endif

#ifndef SELECT_EXIT
	#define SELECT_EXIT 6
#endif
#define NO_POINT 0
#define POINT 1

#ifdef SCENERY_HEADER
	typedef scn_header header_record;
#else
	typedef obj_header header_record; 
#endif

/* This function fills the inmortality and life section */
extern void change_inmortality(int *inmortal, unsigned long int *life);

/* This function fills movement section */
extern void change_movement(int *move_type, char *move_file, int *loop);

/* This function fills shoot section */
extern void change_shoot(int *shoot_type, unsigned long int *count);

/* This function fill the fields of an event_record */
extern void fill_data(event_record *data, char use_point);

/* This function return the correct position (Remember: file is ordered by point) */
extern unsigned long int find_file_position(FILE *f, unsigned long int p);

/* This function selects a background type */
void select_bg(int *bg);

/* This function outputs the data info in listing */
extern void print_data(event_record data);

/* This function shows all events numbered in a point. It is useful for selecting one event */
extern unsigned long int show_events_in_a_point(FILE *f, unsigned long int p);

/* This function list events in a point */
extern void list_events(FILE *f, char *return_menu);
