#include "readpng.h"
	
int readpng(char *filename, png_bytep **image, png_uint_32 *width, png_uint_32 *height) {
	FILE *f;
	png_bytep *ptr;
	png_structp png_ptr;
	png_infop info_ptr;
	int depth, color, interlace, compression, filter;
	int x;
	
	if (!(f = fopen(filename, "rb"))) return FILE_DOESNT_EXIST;
	
	png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	info_ptr = png_create_info_struct(png_ptr);
	setjmp(png_jmpbuf(png_ptr));
	png_init_io(png_ptr, f);
	png_read_info(png_ptr, info_ptr);
	png_get_IHDR(png_ptr, info_ptr, width, height, &depth, &color, &interlace, &compression, &filter);
	
	
	if (!(*image = (png_bytep *) malloc(*height * sizeof(png_bytep)))) return NOT_ENOUGH_MEMORY;
	ptr = *image;
	for (x = 0; x < *height; x++) 
		if (!(ptr[x] = (png_bytep) malloc(*width * sizeof(png_byte)))) return NOT_ENOUGH_MEMORY;
	png_read_rows(png_ptr, *image, NULL, *height);
	png_read_end(png_ptr, NULL);
	
	png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
	fclose(f);
	
	return GOODBYE_OK;
}
