/* Iria - An easy-customizing game, in the way of "Thunder Force IV".
 * Created by Juan Jos Ramrez. Synthetyx Software.
 *
 * svgalibg.h - Definitions and function prototypes for svgalibg.c
 *
 */

#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include <vgamouse.h>
#include <stdio.h>
#include <malloc.h>
#include <png.h>
#include "returns.h"

#define DEFAULT_GRAPHICS_MODE G320x200x256
#define BLACK 0x89
#define WHITE 0x91

#define GEN1(var, fix1, fix2, init, end, val1, val2, mul)	\
	for (i = init; i < end; i++) {			\
		pal[i + 1].var = (i - init) * mul;			\
		pal[i + 1].fix1 = val1;			\
		pal[i + 1].fix2 = val2;			\
	}
#define GEN2(var, fix1, fix2, init, end, val, mul1, mul2) 	\
	for (i = init; i < end; i++) {				\
		pal[i + 1].var = val;				\
		pal[i + 1].fix1 = (i - init) * mul1;			\
		 pal[i + 1].fix2 = (i - init) * mul2;			\
	}				

/* This function gets the selected video mode */
extern int get_graphics_mode();

/* This function makes important graphics initializations */
extern int svga_graphics_initializations(GraphicsContext *phy, GraphicsContext *virt, void **expandedfont, int height);

/* This function returns to text mode and free some variables */
extern void svga_graphics_shutdown(GraphicsContext *virt, void **expandedfont);

/* This function makes keyboard initializations */
extern int svga_keyboard_initializations();

/* This function returns keyboard to normal mode */
extern void svga_keyboard_shutdown();

/* This function makes svga initializations like video mode or keyboard */
extern void svga_initializations(GraphicsContext *phy, GraphicsContext *virt, void **expandedfont, int height);

/* This function shuts down graphics and keyboard raw mode */
extern void svga_shutdown(GraphicsContext *virt, void **expandedfont);
