/* Iria - An easy-customizing game, in the way of "Thunder Force IV".
 * Created by Juan Jos Ramrez. Synthetyx Software.
 *
 * unloadfiles.c - A module for unloading scenery, objects and images.
 *
 */

#include "iria.h"

/* This function unloads scenery events, objects index and images */
void unload_game_elements(scenery_struct *scenery, object_struct **objects_index, image_list *images, unsigned long int number_of_objects) {
	unsigned long int i;
	
	event_destroy(&scenery->events);
	for (i = 0; i < number_of_objects; i++)
		event_destroy(&(*objects_index)[i].events);
	free(*objects_index);
	image_destroy(images);
}

/* This function unloads filename lists like files loaded and images loaded */
void unload_file_lists(string_list *files_loaded, imagefile_list *images_loaded) {
	string_destroy(files_loaded);
	imagefile_destroy(images_loaded);
}
